

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>shyft.dashboard.apps.dtss_viewer.dtss_viewer_app &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../../../" src="../../../../../_static/documentation_options.js"></script>
        <script src="../../../../../_static/jquery.js"></script>
        <script src="../../../../../_static/underscore.js"></script>
        <script src="../../../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../../../index.html">Module code</a> &raquo;</li>
        
      <li>shyft.dashboard.apps.dtss_viewer.dtss_viewer_app</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for shyft.dashboard.apps.dtss_viewer.dtss_viewer_app</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Dict</span><span class="p">,</span> <span class="n">Any</span>
<span class="kn">from</span> <span class="nn">concurrent.futures</span> <span class="kn">import</span> <span class="n">ThreadPoolExecutor</span>

<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.ds_view_handle_registry</span> <span class="kn">import</span> <span class="n">DsViewHandleRegistryApp</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.renderer</span> <span class="kn">import</span> <span class="n">LineRenderer</span><span class="p">,</span> <span class="n">DiamondScatterRenderer</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.view_container.figure</span> <span class="kn">import</span> <span class="n">Figure</span>

<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.ts_viewer</span> <span class="kn">import</span> <span class="n">TsViewer</span>

<span class="kn">from</span> <span class="nn">shyft.dashboard.base.selector_presenter</span> <span class="kn">import</span> <span class="n">SelectorPresenter</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.base.selector_views</span> <span class="kn">import</span> <span class="n">FilterMultiSelect</span>

<span class="kn">from</span> <span class="nn">shyft.dashboard.base.app</span> <span class="kn">import</span> <span class="n">AppBase</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.apps.dtss_viewer.widgets</span> <span class="kn">import</span> <span class="p">(</span><span class="n">ContainerPathReceiver</span><span class="p">,</span>
                                                      <span class="n">TsSelector</span><span class="p">,</span> <span class="n">TsView</span><span class="p">,</span> <span class="n">LineStyleChanger</span><span class="p">)</span>


<span class="kn">import</span> <span class="nn">bokeh</span>
<span class="kn">import</span> <span class="nn">bokeh.layouts</span>
<span class="kn">import</span> <span class="nn">bokeh.models</span>

<span class="kn">from</span> <span class="nn">shyft.dashboard.base.ports</span> <span class="kn">import</span> <span class="n">connect_ports</span><span class="p">,</span> <span class="n">Receiver</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.time_series.view_container.table</span> <span class="kn">import</span> <span class="n">Table</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.widgets.logger_box</span> <span class="kn">import</span> <span class="n">LoggerBox</span>
<span class="kn">from</span> <span class="nn">shyft.dashboard.widgets.message_viewer</span> <span class="kn">import</span> <span class="n">MessageViewer</span>

<span class="kn">import</span> <span class="nn">shyft.time_series</span> <span class="k">as</span> <span class="nn">sa</span>


<div class="viewcode-block" id="DtssViewerApp"><a class="viewcode-back" href="../../../../../content/dashboard/api.html#shyft.dashboard.apps.dtss_viewer.dtss_viewer_app.DtssViewerApp">[docs]</a><span class="k">class</span> <span class="nc">DtssViewerApp</span><span class="p">(</span><span class="n">AppBase</span><span class="p">):</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">thread_pool</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">ThreadPoolExecutor</span><span class="p">]</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="n">app_kwargs</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Any</span><span class="p">]]</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="kc">None</span><span class="p">:</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">thread_pool</span><span class="o">=</span><span class="n">thread_pool</span><span class="p">)</span>
        <span class="n">a</span><span class="o">=</span> <span class="n">app_kwargs</span> <span class="ow">or</span> <span class="p">{}</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">default_host</span><span class="p">:</span><span class="nb">str</span> <span class="o">=</span> <span class="n">a</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;dtss_host&#39;</span><span class="p">,</span><span class="s1">&#39;localhost&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">default_port</span><span class="p">:</span><span class="nb">int</span> <span class="o">=</span> <span class="n">a</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;dtss_port&#39;</span><span class="p">,</span><span class="mi">20000</span><span class="p">)</span>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">name</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        This property returns the name of the app</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="s2">&quot;DTSS Viewer App&quot;</span>

<div class="viewcode-block" id="DtssViewerApp.get_layout"><a class="viewcode-back" href="../../../../../content/dashboard/api.html#shyft.dashboard.apps.dtss_viewer.dtss_viewer_app.DtssViewerApp.get_layout">[docs]</a>    <span class="k">def</span> <span class="nf">get_layout</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">doc</span><span class="p">:</span> <span class="s1">&#39;bokeh.document.Document&#39;</span><span class="p">,</span> <span class="n">logger</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="n">LoggerBox</span><span class="p">]</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="n">bokeh</span><span class="o">.</span><span class="n">models</span><span class="o">.</span><span class="n">LayoutDOM</span><span class="p">:</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        This function returns the full page layout for the app</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">doc</span><span class="o">.</span><span class="n">title</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span>
        <span class="n">event_messenger</span> <span class="o">=</span> <span class="n">MessageViewer</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s1">&#39;Log:&#39;</span><span class="p">,</span> <span class="n">rows</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">2000</span><span class="p">,</span> <span class="n">height</span><span class="o">=</span><span class="mi">200</span><span class="p">,</span> <span class="n">title_hight</span><span class="o">=</span><span class="mi">55</span><span class="p">,</span>
                                        <span class="n">sizing_mode</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">show_time</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">time_zone</span><span class="o">=</span><span class="s1">&#39;Europe/Oslo&#39;</span><span class="p">)</span>

        <span class="n">container_path_input</span> <span class="o">=</span> <span class="n">ContainerPathReceiver</span><span class="p">(</span><span class="n">dtss_host</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">default_host</span><span class="p">,</span><span class="n">dtss_port</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">default_port</span><span class="p">)</span>
        <span class="n">multi_select_view</span> <span class="o">=</span> <span class="n">FilterMultiSelect</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s1">&#39;Time Series in DTSS&#39;</span><span class="p">,</span> <span class="n">height</span><span class="o">=</span><span class="mi">600</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">400</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="mi">40</span><span class="p">,</span><span class="n">padding</span><span class="o">=</span><span class="mi">20</span><span class="p">)</span>
        <span class="n">multi_select_presenter</span> <span class="o">=</span> <span class="n">SelectorPresenter</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;Ts&#39;</span><span class="p">,</span> <span class="n">view</span><span class="o">=</span><span class="n">multi_select_view</span><span class="p">)</span>
        <span class="n">ts_selector</span> <span class="o">=</span> <span class="n">TsSelector</span><span class="p">(</span><span class="n">multi_select_presenter</span><span class="p">)</span>
        <span class="n">utc</span><span class="o">=</span><span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="p">()</span>
        <span class="n">time_range</span> <span class="o">=</span> <span class="n">sa</span><span class="o">.</span><span class="n">UtcPeriod</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2020</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">),</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2021</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">))</span>

        <span class="n">time_step_restrictions</span> <span class="o">=</span> <span class="p">[</span><span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">HOUR</span><span class="p">,</span> <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">HOUR</span><span class="o">*</span><span class="mi">3</span><span class="p">,</span> <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">DAY</span><span class="p">,</span> <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">WEEK</span><span class="p">,</span>
                                  <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span><span class="p">,</span> <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">QUARTER</span><span class="p">,</span> <span class="n">sa</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">YEAR</span><span class="p">]</span>
        <span class="n">ts_viewer</span> <span class="o">=</span> <span class="n">TsViewer</span><span class="p">(</span><span class="n">bokeh_document</span><span class="o">=</span><span class="n">doc</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="s2">&quot;Ts Viewer&quot;</span><span class="p">,</span> <span class="n">padding</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span><span class="n">height</span><span class="o">=</span><span class="mi">50</span><span class="p">,</span><span class="n">thread_pool_executor</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">thread_pool</span><span class="p">,</span>
                             <span class="n">init_view_range</span><span class="o">=</span><span class="n">time_range</span><span class="p">,</span> <span class="n">time_step_restrictions</span><span class="o">=</span><span class="n">time_step_restrictions</span><span class="p">)</span>
        <span class="n">fig</span> <span class="o">=</span> <span class="n">Figure</span><span class="p">(</span><span class="n">viewer</span><span class="o">=</span><span class="n">ts_viewer</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">1500</span><span class="p">,</span> <span class="n">height</span><span class="o">=</span><span class="mi">600</span><span class="p">,</span> <span class="n">init_renderers</span><span class="o">=</span><span class="p">{</span><span class="n">LineRenderer</span><span class="p">:</span> <span class="mi">6</span><span class="p">})</span>
        <span class="n">table1</span> <span class="o">=</span> <span class="n">Table</span><span class="p">(</span><span class="n">viewer</span><span class="o">=</span><span class="n">ts_viewer</span><span class="p">,</span> <span class="n">width</span><span class="o">=</span><span class="mi">1500</span><span class="p">,</span> <span class="n">height</span><span class="o">=</span><span class="mi">600</span><span class="p">)</span>

        <span class="n">view_handle</span> <span class="o">=</span> <span class="n">TsView</span><span class="p">(</span><span class="n">figure</span><span class="o">=</span><span class="n">fig</span><span class="p">,</span> <span class="n">table</span><span class="o">=</span><span class="n">table1</span><span class="p">)</span>

        <span class="n">dsviewhandle_registry</span> <span class="o">=</span> <span class="n">DsViewHandleRegistryApp</span><span class="p">()</span>

        <span class="n">line_style_changer</span> <span class="o">=</span> <span class="n">LineStyleChanger</span><span class="p">()</span>

        <span class="n">connect_ports</span><span class="p">(</span><span class="n">container_path_input</span><span class="o">.</span><span class="n">send_event_message</span><span class="p">,</span> <span class="n">event_messenger</span><span class="o">.</span><span class="n">receive_message</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">ts_selector</span><span class="o">.</span><span class="n">send_event_message</span><span class="p">,</span> <span class="n">event_messenger</span><span class="o">.</span><span class="n">receive_message</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">view_handle</span><span class="o">.</span><span class="n">send_event_message</span><span class="p">,</span> <span class="n">event_messenger</span><span class="o">.</span><span class="n">receive_message</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">line_style_changer</span><span class="o">.</span><span class="n">send_event_message</span><span class="p">,</span> <span class="n">event_messenger</span><span class="o">.</span><span class="n">receive_message</span><span class="p">)</span>

        <span class="n">connect_ports</span><span class="p">(</span><span class="n">container_path_input</span><span class="o">.</span><span class="n">send_dtss_url</span><span class="p">,</span> <span class="n">ts_selector</span><span class="o">.</span><span class="n">receive_url</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">container_path_input</span><span class="o">.</span><span class="n">send_shyft_container</span><span class="p">,</span> <span class="n">ts_selector</span><span class="o">.</span><span class="n">receive_container</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">container_path_input</span><span class="o">.</span><span class="n">send_dtss_url</span><span class="p">,</span> <span class="n">view_handle</span><span class="o">.</span><span class="n">receive_dtss_url</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">ts_selector</span><span class="o">.</span><span class="n">send_selected_time_series</span><span class="p">,</span> <span class="n">view_handle</span><span class="o">.</span><span class="n">receive_time_series</span><span class="p">)</span>

        <span class="n">connect_ports</span><span class="p">(</span><span class="n">view_handle</span><span class="o">.</span><span class="n">send_selected</span><span class="p">,</span> <span class="n">line_style_changer</span><span class="o">.</span><span class="n">receive_ds_view_handles_to_add</span><span class="p">)</span>
        <span class="c1"># connect_ports(view_handle.send_selected, ts_viewer.receive_ds_view_handles_to_add)</span>

        <span class="n">connect_ports</span><span class="p">(</span><span class="n">view_handle</span><span class="o">.</span><span class="n">send_selected</span><span class="p">,</span> <span class="n">dsviewhandle_registry</span><span class="o">.</span><span class="n">receive_ds_view_handles_to_register</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">dsviewhandle_registry</span><span class="o">.</span><span class="n">send_ds_view_handles_to_add</span><span class="p">,</span> <span class="n">ts_viewer</span><span class="o">.</span><span class="n">receive_ds_view_handles_to_add</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">dsviewhandle_registry</span><span class="o">.</span><span class="n">send_ds_view_handles_to_remove</span><span class="p">,</span>
                      <span class="n">ts_viewer</span><span class="o">.</span><span class="n">receive_ds_view_handles_to_remove</span><span class="p">)</span>

        <span class="n">connect_ports</span><span class="p">(</span><span class="n">dsviewhandle_registry</span><span class="o">.</span><span class="n">send_ds_view_handles_to_add</span><span class="p">,</span> <span class="n">line_style_changer</span><span class="o">.</span><span class="n">receive_ds_view_handles_to_add</span><span class="p">)</span>
        <span class="n">connect_ports</span><span class="p">(</span><span class="n">dsviewhandle_registry</span><span class="o">.</span><span class="n">send_ds_view_handles_to_remove</span><span class="p">,</span>
                      <span class="n">line_style_changer</span><span class="o">.</span><span class="n">receive_ds_view_handles_to_remove</span><span class="p">)</span>
        <span class="c1"># ensure we get a flying start sending suitable start values to the container</span>
        <span class="n">container_path_input</span><span class="o">.</span><span class="n">send_dtss_url</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">default_host</span><span class="si">}</span><span class="s1">:</span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">default_port</span><span class="si">}</span><span class="s1">&#39;</span><span class="p">)</span>
        <span class="n">container_path_input</span><span class="o">.</span><span class="n">send_shyft_container</span><span class="p">(</span><span class="s1">&#39;test&#39;</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">column</span><span class="p">(</span><span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">row</span><span class="p">(</span><span class="n">event_messenger</span><span class="o">.</span><span class="n">layout</span><span class="p">),</span>
                                    <span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">row</span><span class="p">(</span>
                                        <span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">column</span><span class="p">(</span>
                                            <span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">row</span><span class="p">(</span><span class="n">container_path_input</span><span class="o">.</span><span class="n">layout_components</span><span class="p">[</span><span class="s2">&quot;widgets&quot;</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span>
                                                              <span class="n">container_path_input</span><span class="o">.</span><span class="n">layout_components</span><span class="p">[</span><span class="s2">&quot;widgets&quot;</span><span class="p">][</span><span class="mi">1</span><span class="p">]),</span>
                                            <span class="c1"># multi_select_view.layout_components[&#39;widgets&#39;][0],</span>
                                            <span class="n">multi_select_view</span><span class="o">.</span><span class="n">layout_components</span><span class="p">[</span><span class="s1">&#39;widgets&#39;</span><span class="p">][</span><span class="mi">1</span><span class="p">],</span>
                                            <span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">row</span><span class="p">(</span><span class="n">dsviewhandle_registry</span><span class="o">.</span><span class="n">layout_components</span><span class="p">[</span><span class="s1">&#39;widgets&#39;</span><span class="p">][</span><span class="mi">1</span><span class="p">],</span>
                                                              <span class="n">dsviewhandle_registry</span><span class="o">.</span><span class="n">layout_components</span><span class="p">[</span><span class="s1">&#39;widgets&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">]),</span>
                                            <span class="n">line_style_changer</span><span class="o">.</span><span class="n">layout</span>
                                        <span class="p">),</span>
                                        <span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">column</span><span class="p">(</span><span class="n">bokeh</span><span class="o">.</span><span class="n">layouts</span><span class="o">.</span><span class="n">row</span><span class="p">(</span><span class="n">ts_viewer</span><span class="o">.</span><span class="n">layout_components</span><span class="p">[</span><span class="s1">&#39;widgets&#39;</span><span class="p">]),</span>
                                                             <span class="n">fig</span><span class="o">.</span><span class="n">layout</span><span class="p">,</span>
                                                             <span class="n">table1</span><span class="o">.</span><span class="n">layout</span><span class="p">)</span>
                                         <span class="p">)</span>
                                    <span class="p">)</span></div></div>

</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>